// CEXML.h: interface for the CCEXML class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CEXML_H__CCE34393_A339_4F76_B1C6_6EE725D4EC68__INCLUDED_)
#define AFX_CEXML_H__CCE34393_A339_4F76_B1C6_6EE725D4EC68__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <objsafe.h>
#include <objbase.h>
#include <msxml2.h>
#include <atlbase.h>


class CCEXML  
{
public:
	CCEXML();
	virtual ~CCEXML();

	BOOL InitialiseAndParse( LPCTSTR szXMLFile );
	CComPtr<IXMLDOMDocument> CCEXML::CreateEmptyDOMDocument();

	// This is a pure virtual function which needs writing by the derived class
	virtual void DisplayChild( IXMLDOMElement* pChild ) = 0 { }

	CString ParseXML( IXMLDOMElement *node );
	CString GetAttributes( CString& strAttribs );

	HRESULT DASetAttribute( BSTR bstrName, BSTR bstrValue, IXMLDOMNode* pNode, IXMLDOMDocument* pDocument );
	HRESULT DAAddChild( BSTR name, int nType, IXMLDOMNode** pOut, IXMLDOMNode* pNode, IXMLDOMDocument* pDocument );

	IXMLDOMDocument* GetDocument() { return m_iXMLDoc; }
	
private:
	void DisplayChildren( IXMLDOMElement* pParent );

protected:
	CComPtr<IXMLDOMDocument> m_iXMLDoc;
};

#endif // !defined(AFX_CEXML_H__CCE34393_A339_4F76_B1C6_6EE725D4EC68__INCLUDED_)
